/*********************************************************************
 *	ȣԣѡʰץ˥.
 *********************************************************************

ؿ:
int		sci_async_getc(void);
void	sci_echo(int c)	// ꥢ˥.;
void	sci_setBaud(int baud);
int		put_char(int c);
int		sci_puts(const char *s);

void	jump( adrs_t adr );
void	printhex1(uchar c);
void	printhex2(uchar c);
void	printhex4(int c);
void	printhex6(int c);
void	printhex8(int c);
void	printsp(void);
void	printcrlf(void);

uchar	str2int(char *s,int *p,char radix);
uchar	get_arg(char *buf);
void	memdump(adrs_t ptr,int len);
int		memPeek(adrs_t adr);
void	memPoke(adrs_t adr,int data0,int data1);
int		str_comp(const char *buf,const char *cmd);
int		cmdHelp(char *buf);
int		cmdQuit(char *buf);
int		cmdDump(char *buf);
int		edit_loop(void);
int		cmdEdit(char *buf);
int		cmdFill(char *buf);
int		cmdJump(char *buf);
int		cmdBaud(char *buf);
int		cmdMonit(char *buf);
int		getline_task(void);
char	*get_line(char *s);
int		Monitor_task(void);
void	getMonitorCmd(void);
int		monitor_main(void);

static	char lc(char c);
static	char is_space(char c);
static	char is_separator(char c);
static	char *space_skip(char *buf);
static	int	hex1int(char c,char radix);
 */

#include <string.h>
#include "monit.h"

char *get_line(char *s);
int sci_puts(const char *s);
#define	 CRLF	"\r\n"

/*********************************************************************
 *	ꥢ뤫ʸ.
 *********************************************************************
 */
int sci_async_getc(void)
{
	if(uart0_test()<=0) return -1;
	return uart0_get();
}

/*********************************************************************
 *	ꥢʸФ.
 *********************************************************************
 */
void sci_putc(int c)
{
	uart0_put(c);
}

/*********************************************************************
 *	ꥢ˥.(CR -> CRLF Ѵդ)
 *********************************************************************
 */
void sci_echo(int c)	// ꥢ˥.
{
	sci_putc(c);
	if(c=='\r') {		// CR ʤ
		sci_putc('\n');	// LF 䴰.
	}
}

/*********************************************************************
 *	ܡ졼Ȼ
 *********************************************************************
 */
void sci_setBaud(int baud)
{
	if( uart0_init(baud) < 0) {
		sci_puts("FATAL:Can't set baudrate!" CRLF );
	}
}

/*********************************************************************
 *	˥إɽ.
 *********************************************************************
 */

const char HELP_MESSAGES[]=
"* ARM/ledmon Ver 0.2" CRLF
"Command" CRLF
" d  <ADDRESS1> <ADDRESS2>        Dump Memory" CRLF
" e  <ADDRESS1> <DATA>            Edit Memory" CRLF
" f  <ADDRESS1> <ADDRESS2> <DATA> Fill Memory" CRLF
" g  <ADDRESS1>                   Goto Address" CRLF
" l                               Load S-format" CRLF
" b  <baudrate>                   Set  Baudrate" CRLF
;

/*********************************************************************
 *	ޥɡץơ֥빽¤:
 *********************************************************************
 */
typedef	struct {
	const char *name;
	int (*func)(char *buf);
} CmdList;


/*********************************************************************
 *	Хѿ:
 *********************************************************************
 */
		int	 adrs1 = 0;
		int	 adrs2 = 0;
		int	 adrs3 = 0;
		int	 memcnt=0;

#define	MAX_INPUT	256
static	char  input_buf[MAX_INPUT];
static	uchar input_cnt = 0;

/*********************************************************************
 *	ʸ.
 *********************************************************************
 */
int	put_char(int c)
{
	uart0_put(c);
	return c;
}

/*********************************************************************
 *	ʸ.
 *********************************************************************
 */
int sci_puts(const char *s)
{
	short c;
	while(1) {
		c = *s++;if(c==0) break;
		put_char(c);
	}
	return 0;
}

/*********************************************************************
 *	ץ¹.
 *********************************************************************
 */
void jump( adrs_t adr )
{
	void (*func)(void);
	func = (void (*)(void)) adr;
	func();
}

/*********************************************************************
 *	ʣ
 *********************************************************************
 */
void printhex1(uchar c)
{
	c &= 0x0f;
	if(c >= 10) {put_char( c-10 + 'a')	;}
	else		{put_char( c    + '0')	;}
}
/*********************************************************************
 *	ʣ
 *********************************************************************
 */
void printhex2(uchar c)
{
	printhex1(c>>4);
	printhex1(c);
}
/*********************************************************************
 *	ʣ
 *********************************************************************
 */
void printhex4(int c)
{
	printhex2(c>>8);
	printhex2(c);
}
/*********************************************************************
 *	ʣ
 *********************************************************************
 */
void printhex6(int c)
{
	printhex2(c>>16);
	printhex4(c);
}
/*********************************************************************
 *	ʣ
 *********************************************************************
 */
void printhex8(int c)
{
	printhex4(c>>16);
	printhex4(c);
}
/*********************************************************************
 *	ʸ.
 *********************************************************************
 */
void printsp(void)
{
	put_char(' ');
}
/*********************************************************************
 *	ʸ.
 *********************************************************************
 */
void printcrlf(void)
{
	sci_puts("\r\n");
}
/*********************************************************************
 *	ʸ·.
 *********************************************************************
 */
static	char lc(char c)
{
	if((c>='A')&&(c<='Z')) c += 0x20;	// lower case.
	return c;
}

/*********************************************************************
 *	ʸ c ʸʤ飱֤.
 *********************************************************************
 */
static	char is_space(char c)
{
	if((c==' ') || (c=='\t')) return 1;
	return 0;
}
/*********************************************************************
 *	ʸ c ʸʤ飱֤.
 *********************************************************************
 */
static	char is_separator(char c)
{
	if(is_space(c)) return 1;
	if(c==',') return 1;
	return 0;
}
/*********************************************************************
 *	ʸ *buf Ƭ;ɤФ.
 *********************************************************************
 */
static	char *space_skip(char *buf)
{
	while(*buf) {
		if(is_space(*buf)==0) return buf;
		buf++;
	}
	return buf;
}

/**********************************************************************
 *	ʸ(c)(0..15)Ѵ.
 **********************************************************************
 *	:
 *		char c    :	ʸASCII.
 *		char radix: 10 ⤷16.
 *	:
 *		0..15 ο͡⤷ (-1) Ѵʤ
 */
static	int	hex1int(char c,char radix)
{
	if((c>='0')&&(c<='9')) return c - '0';
	if(radix == 10) return -1;

	// ʿ򰷤.
	if((c>='a')&&(c<='f')) return c - 'a' + 10;
	if((c>='A')&&(c<='F')) return c - 'A' + 10;
	return -1;
}

/****************************************************************************
 *	ʸͤѴ.
 ****************************************************************************
 * :
 *	char *s : ʸݥ.
 *	int  *p : ̤֤ݥ.
 *	char radix : 10 ⤷ 16
 * :
 *  ɤ߿ʤ᤿ʸ , 0 ξѴǽ.
 */
uchar str2int(char *s,int *p,char radix)
{
	int   n;
	uchar idx=0;	//ɤ߿ʤ᤿ʸ.
	int	  val=0;	//Ѵ줿.

	n = hex1int(*s,radix);if(n<0) return 0;

	// ɤ߼.
	while(1) {
		n = hex1int(*s,radix);if(n<0) break;
		val = val * radix + n;
		s++;
		idx++;
	}
	*p = val;
	
	// ڤʸå.
	while(1) {
		if(is_separator(*s)==0) break;
		s++;
		idx++;
	}
	return idx;
}

/****************************************************************************
 *	˥ޥɰɾ.
 ****************************************************************************
 * :
 *	char *buf : ʸ.
 * :
 *	θĿ֤
 *
 * ƶ륰Хѿ:
 *	adrs1     : 裱򣱣ʸȤɾ.
 *	adrs2     : 裲򣱣ʸȤɾ.
 *	memcnt    : adrs2 - adrs1 + 1
 */
uchar get_arg(char *buf)
{
	uchar idx;

	memcnt = 256;
	adrs2 = (-1);

	// ޥɤθζɤФ.
	buf = space_skip(buf);

	//ǽΰ.	start_adrs Ȥߤʤ.
	idx = str2int(buf, &adrs1 ,16);
	if(idx == 0) return 0;	// ʤ.

	//ܤΰ.	end_adrs Ȥߤʤ.
	buf += idx;
	idx = str2int(buf, &adrs2 ,16);
	if(idx == 0) return 1;	// ϣ.

	memcnt = adrs2 - adrs1 + 1;
	if(	memcnt < 0) {		//  end_adrs ǤʤĹǤȤߤʤ.
		memcnt = adrs2;
	}
	buf += idx;
	idx = str2int(buf, &adrs3 ,16);
	if(idx == 0) return 2;	// ϣ.

	return 3;
}
/****************************************************************************
 *	꡼Ƥ.
 ****************************************************************************
 */
void memdump(adrs_t ptr,int len)
{
	uchar *p = (uchar *) ptr;

	int i,j,c;

	for(i=0;i<len;i++) {
		if( (i & 15) == 0 ) {
			printhex6( (adrs_t) p );
		}
		printsp();printhex2(*p);p++;
		if( (i & 15) == 15 ) {
#if	1	// ASCII DUMP
			printsp();
			for(j=0;j<16;j++) {
				c=p[j-16];
				if(c<' ')   c='.';
				if(c>=0x7f) c='.';
				put_char(c);
			}
#endif
			printcrlf();
		}
	}
}

/*********************************************************************
 *	꡼Ƥɤ߼.
 *********************************************************************
 */
int memPeek(adrs_t adr)
{
	uchar *p = (uchar*) adr;
	return *p;
}
/*********************************************************************
 *	꡼Ƥν񤭹.
 *********************************************************************
 */
void memPoke(adrs_t adr,int data0,int data1)
{
	uchar *p = (uchar*) adr;
	if(data1) {	//ޥդν񤭹.
		*p = (*p & data1) | data0;
	}else{			//٤񤭹.
		*p = data0;
	}
}

/*********************************************************************
 *	ʸ *buf ޥ̾ *cmd ޤǤ뤫ɤĴ٤.
 *********************************************************************
 */
int	str_comp(const char *buf,const char *cmd)
{
	while(*cmd) {
		if(lc(*buf) != lc(*cmd)) {return 1;}	// ԰.
		cmd++;
		buf++;
	}
	return 0;
}
/*********************************************************************
 *	ȣţ̣
 *********************************************************************
 */
int cmdHelp(char *buf)
{
	sci_puts( HELP_MESSAGES );
	return 0;
}

/*********************************************************************
 *	λ.
 *********************************************************************
 */
int	cmdQuit(char *buf)
{
	sci_puts("Bye.\r\n");
	return 1;
}
/*********************************************************************
 *	꡼פμ¹.
 *********************************************************************
 */
int	cmdDump(char *buf)
{
	get_arg(buf);
	memdump(adrs1 ,(memcnt+15)&(-16));
	adrs1 += memcnt;
	return 0;
}
/*********************************************************************
 *	꡼ƤԽ:롼.
 *********************************************************************
 */
int	edit_loop(void)
{
	char *buf;
	uchar idx;
	// ꡼Ƥɽ.
	int  val;

	// ꡼񤭴μ.
	while(1) {
		val = memPeek(adrs1);
		printhex6(adrs1);printsp();printhex2(val);

		buf = get_line(" :");
		idx = str2int(buf, &adrs2 ,16);
		if(idx==0) {	// ʿϤʤä.
			sci_puts("\r\n");
			return 0;
		}
		memPoke(adrs1 ,adrs2 , 0);	// ꡼ͤ񤭹.
		adrs1++;		
	}
}
/*********************************************************************
 *	꡼ƤԽ.
 *********************************************************************
 */
int	cmdEdit(char *buf)
{
	uchar idx;
	// ޥɤθζɤФ.
	buf = space_skip(buf);

	//ǽΰ.	start_adrs Ȥߤʤ.
	idx = str2int(buf, &adrs1 ,16);
	if(idx == 0) return 0;	// ʤ.

	//ܤΰ.	data Ȥߤʤ.
	buf += idx;
	idx = str2int(buf, &adrs2 ,16);
	if(idx == 0) {	// ϣ.
		return edit_loop();
	}

	memPoke(adrs1 ,adrs2 , 0);	// ꡼ͤ񤭹.
	adrs1++;		
	buf += idx;
	
	while(1) {		// ³ǡϢ³ƽ.
		idx = str2int(buf, &adrs2 ,16);
		if(idx == 0) return 0;
		memPoke(adrs1 ,adrs2 , 0);
		adrs1++;		
		buf += idx;
	}
	return 0;
}
/*********************************************************************
 *	꡼եμ¹.
 *********************************************************************
 */
int	cmdFill(char *buf)
{
	int i;
	if( get_arg(buf) >= 3) {
		for(i=adrs1;i<=adrs2;i++) {
			memPoke(i,adrs3,0);
		}
	}
	return 0;
}

/*********************************************************************
 *	Ϥ¹.
 *********************************************************************
 */
int	cmdJump(char *buf)
{
	int argc = get_arg(buf);
	if(	argc >= 1) {
		jump( adrs1 );
	}
	return 0;
}

/*********************************************************************
 *	ܡ졼.
 *********************************************************************
 */
int cmdBaud(char *buf)
{
	int baud=0;

	// ޥɤθζɤФ.
	buf = space_skip(buf);

	str2int(buf,&baud,10);
	if(baud) {
		sci_setBaud( baud );
	}
	return 0;
}

/*********************************************************************
 *	ӥեޥåȤɤ߹.
 *********************************************************************
 */
//int cmdLoad(char *buf);

/*********************************************************************
 *	˥ޥɥơ֥.
 *********************************************************************
 */
const CmdList cmdlist[]={
	{	"h"	,	cmdHelp },
	{	"?"	,	cmdHelp },
	{	"d"	,	cmdDump },
	{	"e"	,	cmdEdit },
	{	"f"	,	cmdFill },
	{	"g"	,	cmdJump },
//	{	"l"	,	cmdLoad },
//	{	"S0",	cmdLoad },
	{	"b"	,	cmdBaud },
	{	"q"	,	cmdQuit },
	{	NULL,	cmdQuit },
};
/*********************************************************************
 *	˥ޥɲϤȼ¹.
 *********************************************************************
 	quit  1 ֤.
 */
int	cmdMonit(char *buf)
{
	const CmdList *t;
	for(t = cmdlist; t->name != NULL ; t++) {
		if( str_comp(buf ,t->name)==0 ) {
			buf += strlen(t->name);
			return t->func(buf);
		}
	}
	/*error*/
	sci_puts("?> ");
	sci_puts(buf);
	sci_puts("\r\n");
	return 0;
}

/*********************************************************************
 *	Ϥμ¹.
 *********************************************************************
 * ۤΰ
 *
 *	ϥХåե 		 : input_buf[]
 *	ϺѤߤʸ : input_cnt
 *
 * ͡
 *
 *	Ϥλ '\r' ֤.
 *	ʸ̵뤤ӾΤȤ -1 ֤.
 */
int	getline_task(void)
{
	short c = sci_async_getc();
	if(c < 0) return c;				//̵.

	sci_echo(c);	// ꥢ˥.

	// Ԥʤ顢뤹.
	if( c == '\r' ) {
		input_buf[input_cnt] = 0;
		input_cnt = 0;
		return c;			// .
	}

	// £(DEL)ʤ顢ʸ.
	if((c == 0x08 )||(c== 0x7f)) {
		if(input_cnt!=0) input_cnt--;
		return -1;
	}

	// CLR ʤ顢ʸ.
	if(c == 0x0c ) {
		input_cnt = 0;
		return -1;
	}

	// ԰ʳʸʤ ԥХåեˤ.
	if(	input_cnt < MAX_INPUT ) {
		input_buf[input_cnt++] = c;
	}

	return -1;
}
/*********************************************************************
 *	ϤԤʤ.
 *********************************************************************
 */
char *get_line(char *s)
{
	sci_puts(s);
	while( getline_task() < 0) ;	//Ϥλ >=0
	return input_buf;
}

/*********************************************************************
 *	ϤԤʤMonitorޥɤȤߤʤƼ¹Ԥ.
 *********************************************************************
 */
void	Monitor_cmd(void)
{
	int rc = 0;

	if( getline_task() >= 0) {	//Ϥλ >=0
		if(input_buf[0]) {
			rc = cmdMonit(input_buf);	// quitλ 1 ֤.
		}
		sci_puts("\r:");
	}
//	return rc;
}

/*********************************************************************
 *	ϤԤʤMonitorޥɤȤߤʤƼ¹Ԥ.
 *********************************************************************
 */
void	Monitor_task(void)
{
	while(1) {
		Monitor_cmd();
		Sleep(0);
	}
}
/*********************************************************************
 *
 *********************************************************************
 */
